diff -urN punbb-1.4.1/delete.php punbb-1.4.2/delete.php
--- punbb-1.4.1/delete.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/delete.php	2012-02-09 20:42:20.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Deletes the specified post (and, if necessary, the topic it is in).
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -102,11 +102,31 @@
 		// Delete just this one post
 		delete_post($id, $cur_post['tid'], $cur_post['fid']);
 
+		// Fetch previus post #id in some topic for redirect after delete
+		$query = array(
+			'SELECT'	=> 'p.id',
+			'FROM'		=> 'posts AS p',
+			'WHERE'		=> 'p.topic_id = '.$cur_post['tid'].' AND p.id < '.$id,
+			'ORDER BY'	=> 'p.id DESC',
+			'LIMIT'		=> '1'
+		);
+
+		($hook = get_hook('dl_post_deleted_get_prev_post_id')) ? eval($hook) : null;
+		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
+		$prev_post = $forum_db->fetch_assoc($result);
+
 		$forum_flash->add_info($lang_delete['Post del redirect']);
 
 		($hook = get_hook('dl_post_deleted_pre_redirect')) ? eval($hook) : null;
 
-		redirect(forum_link($forum_url['topic'], array($cur_post['tid'], sef_friendly($cur_post['subject']))), $lang_delete['Post del redirect']);
+		if (isset($prev_post['id']))
+		{
+			redirect(forum_link($forum_url['post'], $prev_post['id']), $lang_delete['Post del redirect']);
+		}
+		else
+		{
+			redirect(forum_link($forum_url['topic'], array($cur_post['tid'], sef_friendly($cur_post['subject']))), $lang_delete['Post del redirect']);
+		}
 	}
 }
 
@@ -128,8 +148,7 @@
 // Setup form information
 $forum_page['frm_info'] = array(
 	'<li><span>'.$lang_delete['Forum'].':<strong> '.forum_htmlencode($cur_post['forum_name']).'</strong></span></li>',
-	'<li><span>'.$lang_delete['Topic'].':<strong> '.forum_htmlencode($cur_post['subject']).'</strong></span></li>',
-	'<li><span>'.sprintf((($cur_post['is_topic']) ? $lang_delete['Delete topic info'] : $lang_delete['Delete post info']), forum_htmlencode($cur_post['poster']), format_time($cur_post['posted'])).'</span></li>'
+	'<li><span>'.$lang_delete['Topic'].':<strong> '.forum_htmlencode($cur_post['subject']).'</strong></span></li>'
 );
 
 // Generate the post heading
@@ -206,7 +225,7 @@
 			</fieldset>
 <?php ($hook = get_hook('dl_confirm_delete_fieldset_end')) ? eval($hook) : null; ?>
 			<div class="frm-buttons">
-				<span class="submit primary"><input type="submit" name="delete" value="<?php echo ($cur_post['is_topic']) ? $lang_delete['Delete topic'] : $lang_delete['Delete post'] ?>" /></span>
+				<span class="submit primary caution"><input type="submit" name="delete" value="<?php echo ($cur_post['is_topic']) ? $lang_delete['Delete topic'] : $lang_delete['Delete post'] ?>" /></span>
 				<span class="cancel"><input type="submit" name="cancel" value="<?php echo $lang_common['Cancel'] ?>" formnovalidate /></span>
 			</div>
 		</form>
diff -urN punbb-1.4.1/edit.php punbb-1.4.2/edit.php
--- punbb-1.4.1/edit.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/edit.php	2012-02-09 20:42:20.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Modifies the contents of the specified post.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -284,7 +284,7 @@
 
 ?>
 		<div id="req-msg" class="req-warn ct-box error-box">
-			<p class="important"><?php echo $lang_common['Required warn']; ?></p>
+			<p class="important"><?php echo $lang_common['Required warn'] ?></p>
 		</div>
 		<form id="afocus" class="frm-form frm-ctrl-submit" method="post" accept-charset="utf-8" action="<?php echo $forum_page['form_action'] ?>"<?php if (!empty($forum_page['form_attributes'])) echo ' '.implode(' ', $forum_page['form_attributes']) ?>>
 			<div class="hidden">
@@ -303,7 +303,7 @@
 <?php endif; ($hook = get_hook('ed_pre_message_box')) ? eval($hook) : null; ?>				<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="txt-box textarea required">
 						<label for="fld<?php echo ++ $forum_page['fld_count'] ?>"><span><?php echo $lang_post['Write message'] ?></span></label>
-						<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="req_message" rows="14" cols="95" required spellcheck="true"><?php echo forum_htmlencode(isset($_POST['req_message']) ? $message : $cur_post['message']) ?></textarea></span></div>
+						<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="req_message" rows="15" cols="95" required spellcheck="true"><?php echo forum_htmlencode(isset($_POST['req_message']) ? $message : $cur_post['message']) ?></textarea></span></div>
 					</div>
 				</div>
 <?php
@@ -333,7 +333,7 @@
 ?>
 				<fieldset class="mf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="mf-box checkbox">
-						<?php echo implode("\n\t\t\t\t\t", $forum_page['checkboxes'])."\n"; ?>
+						<?php echo implode("\n\t\t\t\t\t", $forum_page['checkboxes'])."\n" ?>
 					</div>
 <?php ($hook = get_hook('ed_pre_checkbox_fieldset_end')) ? eval($hook) : null; ?>
 				</fieldset>
diff -urN punbb-1.4.1/extern.php punbb-1.4.2/extern.php
--- punbb-1.4.1/extern.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/extern.php	2012-02-09 20:42:20.000000000 +0000
@@ -5,57 +5,54 @@
  * Allows forum content to be syndicated outside of the site in various formats
  * (ie: RSS, Atom, XML, HTML).
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 /***********************************************************************
 
-  INSTRUCTIONS
+	INSTRUCTIONS
 
-  This script is used to include information about your board from
-  pages outside the forums and to syndicate news about recent
-  discussions via RSS/Atom/XML. The script can display a list of
-  recent discussions, a list of active users or a collection of
-  general board statistics. The script can be called directly via
-  an URL, from a PHP include command or through the use of Server
-  Side Includes (SSI).
-
-  The scripts behaviour is controlled via variables supplied in the
-  URL to the script. The different variables are: action (what to
-  do), show (how many items to display), fid (the ID or ID's of
-  the forum(s) to poll for topics), nfid (the ID or ID's of forums
-  that should be excluded), tid (the ID of the topic from which to
-  display posts) and type (output as HTML or RSS). The only
-  mandatory variable is action. Possible/default values are:
-
-    action: feed - show most recent topics/posts (HTML or RSS)
-            online - show users online (HTML)
-            online_full - as above, but includes a full list (HTML)
-            stats - show board statistics (HTML)
-
-    type:   rss - output as RSS 2.0
-            atom - output as Atom 1.0
-            xml - output as XML
-            html - output as HTML (<li>'s)
-
-    fid:    One or more forum ID's (comma-separated). If ignored,
-            topics from all readable forums will be pulled.
-
-    nfid:   One or more forum ID's (comma-separated) that are to be
-            excluded. E.g. the ID of a a test forum.
-
-    tid:    A topic ID from which to show posts. If a tid is supplied,
-            fid and nfid are ignored.
-
-    show:   Any integer value between 1 and 50. The default is 15.
-
-    sort:	posted - sort topics by posted time (default)
-			last_post - sort topics by last post
+	This script is used to include information about your board from
+	pages outside the forums and to syndicate news about recent
+	discussions via RSS/Atom/XML. The script can display a list of
+	recent discussions, a list of active users or a collection of
+	general board statistics. The script can be called directly via
+	an URL, from a PHP include command or through the use of Server
+	Side Includes (SSI).
+
+	The scripts behaviour is controlled via variables supplied in the
+	URL to the script. The different variables are: action (what to
+	do), show (how many items to display), fid (the ID or ID's of
+	the forum(s) to poll for topics), nfid (the ID or ID's of forums
+	that should be excluded), tid (the ID of the topic from which to
+	display posts) and type (output as HTML or RSS). The only
+	mandatory variable is action. Possible/default values are:
+
+		action: feed - show most recent topics/posts (HTML or RSS)
+				online - show users online (HTML)
+				online_full - as above, but includes a full list (HTML)
+				stats - show board statistics (HTML)
+
+		type:   rss - output as RSS 2.0
+				atom - output as Atom 1.0
+				xml - output as XML
+				html - output as HTML (<li>'s)
+
+		fid:    One or more forum ID's (comma-separated). If ignored,
+				topics from all readable forums will be pulled.
+
+		nfid:   One or more forum ID's (comma-separated) that are to be
+				excluded. E.g. the ID of a a test forum.
 
+		tid:    A topic ID from which to show posts. If a tid is supplied,
+				fid and nfid are ignored.
 
+		show:   Any integer value between 1 and 50. The default is 15.
 
+		sort:	posted - sort topics by posted time (default)
+				last_post - sort topics by last post
 
 /***********************************************************************/
 
@@ -69,7 +66,7 @@
 
 // The length at which topic subjects will be truncated (for HTML output)
 if (!defined('FORUM_EXTERN_MAX_SUBJECT_LENGTH'))
-    define('FORUM_EXTERN_MAX_SUBJECT_LENGTH', 30);
+	define('FORUM_EXTERN_MAX_SUBJECT_LENGTH', 30);
 
 // If we're a guest and we've sent a username/pass, we can try to authenticate using those details
 if ($forum_user['is_guest'] && isset($_SERVER['PHP_AUTH_USER']))
@@ -165,7 +162,7 @@
 	echo '<feed xmlns="http://www.w3.org/2005/Atom">'."\n";
 
 	echo "\t".'<title type="html"><![CDATA['.escape_cdata($feed['title']).']]></title>'."\n";
-	echo "\t".'<link rel="self" href="'.forum_htmlencode(get_current_url()).'"/>'."\n";
+	echo "\t".'<link rel="self" href="'.forum_htmlencode(get_current_url()).'" />'."\n";
 	echo "\t".'<updated>'.gmdate('Y-m-d\TH:i:s\Z', count($feed['items']) ? $feed['items'][0]['pubdate'] : time()).'</updated>'."\n";
 
 	if ($forum_config['o_show_version'] == '1')
@@ -183,7 +180,7 @@
 	{
 		echo "\t\t".'<entry>'."\n";
 		echo "\t\t\t".'<title type="html"><![CDATA['.escape_cdata($item['title']).']]></title>'."\n";
-		echo "\t\t\t".'<link rel="alternate" href="'.$item['link'].'"/>'."\n";
+		echo "\t\t\t".'<link rel="alternate" href="'.$item['link'].'" />'."\n";
 		echo "\t\t\t".'<'.$content_tag.' type="html"><![CDATA['.escape_cdata($item['description']).']]></'.$content_tag.'>'."\n";
 		echo "\t\t\t".'<author>'."\n";
 		echo "\t\t\t\t".'<name><![CDATA['.escape_cdata($item['author']['name']).']]></name>'."\n";
@@ -327,7 +324,7 @@
 
 		// Setup the feed
 		$feed = array(
-			'title' 		=>	$forum_config['o_board_title'].$lang_common['Title separator'].$cur_topic['subject'],
+			'title'		=>	$forum_config['o_board_title'].$lang_common['Title separator'].$cur_topic['subject'],
 			'link'			=>	forum_link($forum_url['topic'], array($tid, sef_friendly($cur_topic['subject']))),
 			'description'	=>	sprintf($lang_common['RSS description topic'], $cur_topic['subject']),
 			'items'			=>	array(),
@@ -439,7 +436,7 @@
 
 		// Setup the feed
 		$feed = array(
-			'title' 		=>	$forum_config['o_board_title'].$forum_name,
+			'title'			=>	$forum_config['o_board_title'].$forum_name,
 			'link'			=>	forum_link($forum_url['index']),
 			'description'	=>	sprintf($lang_common['RSS description'], $forum_config['o_board_title']),
 			'items'			=>	array(),
diff -urN punbb-1.4.1/footer.php punbb-1.4.2/footer.php
--- punbb-1.4.1/footer.php	2011-11-27 18:23:16.000000000 +0000
+++ punbb-1.4.2/footer.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Outputs the footer used by most forum pages.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -60,8 +60,28 @@
 	if (defined('FORUM_DEBUG'))
 	{
 		// Calculate script generation time
-		$time_diff = forum_number_format(forum_microtime() - $forum_start, 3);
-		echo '<p id="querytime" class="quiet">'.sprintf($lang_common['Querytime'], $time_diff, forum_number_format($forum_db->get_num_queries())).'</p>'."\n";
+		$time_diff = forum_microtime() - $forum_start;
+		$query_time_total = $time_percent_db = 0.0;
+
+		$saved_queries = $forum_db->get_saved_queries();
+		if (count($saved_queries) > 0)
+		{
+			foreach ($saved_queries as $cur_query)
+			{
+				$query_time_total += $cur_query[1];
+			}
+
+			if ($query_time_total > 0 && $time_diff > 0)
+			{
+				$time_percent_db = ($query_time_total / $time_diff) * 100;
+			}
+		}
+
+		echo '<p id="querytime" class="quiet">'.sprintf($lang_common['Querytime'],
+			forum_number_format($time_diff, 3),
+			forum_number_format(100 - $time_percent_db, 0),
+			forum_number_format($time_percent_db, 0),
+			forum_number_format($forum_db->get_num_queries())).'</p>'."\n";
 	}
 
 	if (defined('FORUM_SHOW_QUERIES'))
diff -urN punbb-1.4.1/header.php punbb-1.4.2/header.php
--- punbb-1.4.1/header.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/header.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Outputs the header used by most forum pages.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -54,7 +54,7 @@
 while (preg_match('#<!-- ?forum_include "([^/\\\\]*?)" ?-->#', $tpl_main, $cur_include))
 {
 	if (!file_exists(FORUM_ROOT.'include/user/'.$cur_include[1]))
-		error('Unable to process user include &lt;!-- forum_include "'.forum_htmlencode($cur_include[1]).'" --&gt; from template main.tpl.<br/>There is no such file in folder /include/user/', __FILE__, __LINE__);
+		error('Unable to process user include &lt;!-- forum_include "'.forum_htmlencode($cur_include[1]).'" --&gt; from template main.tpl.<br />There is no such file in folder /include/user/', __FILE__, __LINE__);
 
 	ob_start();
 	include FORUM_ROOT.'include/user/'.$cur_include[1];
@@ -98,7 +98,7 @@
 else if (FORUM_PAGE == 'viewtopic')
 {
 	$forum_head['rss'] = '<link rel="alternate" type="application/rss+xml" href="'.forum_link($forum_url['topic_rss'], $id).'" title="RSS" />';
-	$forum_head['atom'] =  '<link rel="alternate" type="application/atom+xml" href="'.forum_link($forum_url['topic_atom'], $id).'" title="ATOM" />';
+	$forum_head['atom'] = '<link rel="alternate" type="application/atom+xml" href="'.forum_link($forum_url['topic_atom'], $id).'" title="ATOM" />';
 }
 
 // If there are other page navigation links (first, next, prev and last)
@@ -229,7 +229,7 @@
 	$result_header = $forum_db->query_build($query) or error(__FILE__, __LINE__);
 
 	if ($forum_db->result($result_header))
-		$admod_links['reports'] = '<span id="reports"><a href="'.forum_link($forum_url['admin_reports']).'">'.$lang_common['New reports'].'</a></span>';
+		$admod_links['reports'] = '<li id="reports"><a href="'.forum_link($forum_url['admin_reports']).'">'.$lang_common['New reports'].'</a></li>';
 }
 
 if ($forum_user['g_id'] == FORUM_ADMIN)
@@ -258,12 +258,12 @@
 		$alert_items['newer_database'] = '<p><strong>'.$lang_common['Database mismatch'].'</strong> '.$lang_common['Database mismatch alert'].'</p>';
 
 	if (!empty($alert_items))
-		$admod_links['alert'] = '<span id="alert"><a href="'.forum_link($forum_url['admin_index']).'"><strong>'.$lang_common['New alerts'].'</strong></a></span>';
+		$admod_links['alert'] = '<li id="alert"><a href="'.forum_link($forum_url['admin_index']).'">'.$lang_common['New alerts'].'</a></li>';
 
 	($hook = get_hook('hd_alert')) ? eval($hook) : null;
 }
 
-$tpl_main = str_replace('<!-- forum_admod -->', (!empty($admod_links)) ? '<p id="brd-admod">'.implode(' ', $admod_links).'</p>' : '', $tpl_main);
+$tpl_main = str_replace('<!-- forum_admod -->', (!empty($admod_links)) ? '<ul id="brd-admod">'.implode(' ', $admod_links).'</ul>' : '', $tpl_main);
 
 // END SUBST - <!-- forum_admod -->
 
@@ -277,7 +277,7 @@
 // Bottom breadcrumbs
 $main_elements['<!-- forum_crumbs_end -->'] = (FORUM_PAGE != 'index') ? '<div id="brd-crumbs-end" class="crumbs">'."\n\t".'<p>'.generate_crumbs(false).'</p>'."\n".'</div>' : '';
 // Main section heading
-$main_elements['<!-- forum_main_title -->'] =  '<h1 class="main-title">'.((isset($forum_page['main_title'])) ? $forum_page['main_title'] : forum_htmlencode(is_array($last_crumb = end($forum_page['crumbs'])) ? reset($last_crumb) : $last_crumb)).(isset($forum_page['main_head_pages']) ? ' <small>'.$forum_page['main_head_pages'].'</small>' : '').'</h1>'."\n";
+$main_elements['<!-- forum_main_title -->'] = '<h1 class="main-title">'.((isset($forum_page['main_title'])) ? $forum_page['main_title'] : forum_htmlencode(is_array($last_crumb = end($forum_page['crumbs'])) ? reset($last_crumb) : $last_crumb)).(isset($forum_page['main_head_pages']) ? ' <small>'.$forum_page['main_head_pages'].'</small>' : '').'</h1>'."\n";
 
 // Top pagination and post links
 $main_elements['<!-- forum_main_pagepost_top -->'] = (!empty($forum_page['page_post'])) ? '<div id="brd-pagepost-top" class="main-pagepost gen-content">'."\n\t".implode("\n\t", $forum_page['page_post'])."\n".'</div>' : '';
@@ -299,7 +299,7 @@
 
 ($hook = get_hook('hd_main_elements')) ? eval($hook) : null;
 
-$tpl_main = str_replace(array_keys($main_elements),  array_values($main_elements), $tpl_main);
+$tpl_main = str_replace(array_keys($main_elements), array_values($main_elements), $tpl_main);
 unset($main_elements);
 
 // END MAIN SECTION INTERFACE ELEMENT SUBSTITUTION
diff -urN punbb-1.4.1/help.php punbb-1.4.2/help.php
--- punbb-1.4.1/help.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/help.php	2012-02-09 20:42:20.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Provides examples of how to use various features of the forum (ie: BBCode, smilies).
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
diff -urN punbb-1.4.1/include/cache.php punbb-1.4.2/include/cache.php
--- punbb-1.4.1/include/cache.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/cache.php	2012-02-09 20:42:20.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * This file contains all of the functions used to generate the cache files used by the site.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -79,7 +79,7 @@
 	// Output config as PHP code
 	if (!write_cache_file(FORUM_CACHE_DIR.'cache_config.php', '<?php'."\n\n".'define(\'FORUM_CONFIG_LOADED\', 1);'."\n\n".'$forum_config = '.var_export($output, true).';'."\n\n".'?>'))
 	{
-		error('Unable to write configuration cache file to cache directory.<br/>Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
+		error('Unable to write configuration cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
 	}
 }
 
@@ -118,7 +118,7 @@
 	// Output ban list as PHP code
 	if (!write_cache_file(FORUM_CACHE_DIR.'cache_bans.php', '<?php'."\n\n".'define(\'FORUM_BANS_LOADED\', 1);'."\n\n".'$forum_bans = '.var_export($output, true).';'."\n\n".'?>'))
 	{
-		error('Unable to write bans cache file to cache directory.<br/>Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
+		error('Unable to write bans cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
 	}
 }
 
@@ -151,7 +151,7 @@
 	// Output ranks list as PHP code
 	if (!write_cache_file(FORUM_CACHE_DIR.'cache_ranks.php', '<?php'."\n\n".'define(\'FORUM_RANKS_LOADED\', 1);'."\n\n".'$forum_ranks = '.var_export($output, true).';'."\n\n".'?>'))
 	{
-		error('Unable to write ranks cache file to cache directory.<br/>Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
+		error('Unable to write ranks cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
 	}
 }
 
@@ -212,13 +212,25 @@
 	// Output ranks list as PHP code
 	if (!write_cache_file(FORUM_CACHE_DIR.'cache_stats.php', '<?php'."\n\n".'if (!defined(\'FORUM_STATS_LOADED\')) define(\'FORUM_STATS_LOADED\', 1);'."\n\n".'$forum_stats = '.var_export($stats, true).';'."\n\n".'?>'))
 	{
-		error('Unable to write stats cache file to cache directory.<br/>Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
+		error('Unable to write stats cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
 	}
 
 	unset($stats);
 }
 
 
+//
+// Clean stats cache PHP scripts
+//
+function clean_stats_cache()
+{
+	$cache_file = FORUM_CACHE_DIR.'cache_stats.php';
+	if (file_exists($cache_file))
+	{
+		unlink($cache_file);
+	}
+}
+
 
 //
 // Generate the censor cache PHP script
@@ -248,7 +260,7 @@
 	// Output censors list as PHP code
 	if (!write_cache_file(FORUM_CACHE_DIR.'cache_censors.php', '<?php'."\n\n".'define(\'FORUM_CENSORS_LOADED\', 1);'."\n\n".'$forum_censors = '.var_export($output, true).';'."\n\n".'?>'))
 	{
-		error('Unable to write censor cache file to cache directory.<br/>Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
+		error('Unable to write censor cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
 	}
 }
 
@@ -358,7 +370,7 @@
 		// Output quickjump as PHP code
 		if (!write_cache_file(FORUM_CACHE_DIR.'cache_quickjump_'.$group_id.'.php', $output))
 		{
-			error('Unable to write quickjump cache file to cache directory.<br/>Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
+			error('Unable to write quickjump cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
 		}
 	}
 }
@@ -470,7 +482,7 @@
 	// Output hooks as PHP code
 	if (!write_cache_file(FORUM_CACHE_DIR.'cache_hooks.php', '<?php'."\n\n".'define(\'FORUM_HOOKS_LOADED\', 1);'."\n\n".'$forum_hooks = '.var_export($output, true).';'."\n\n".'?>'))
 	{
-		error('Unable to write hooks cache file to cache directory.<br/>Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
+		error('Unable to write hooks cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
 	}
 }
 
@@ -529,7 +541,7 @@
 	// Output update status as PHP code
 	if (!write_cache_file(FORUM_CACHE_DIR.'cache_updates.php', '<?php'."\n\n".'if (!defined(\'FORUM_UPDATES_LOADED\')) define(\'FORUM_UPDATES_LOADED\', 1);'."\n\n".'$forum_updates = '.var_export($output, true).';'."\n\n".'?>'))
 	{
-		error('Unable to write updates cache file to cache directory.<br/>Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
+		error('Unable to write updates cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
 	}
 }
 
@@ -540,17 +552,17 @@
 
 	foreach (array_unique(array_merge($repository_urls, $repository_url_by_extension)) as $url)
 	{
-		//Get repository timestamp
-		$remote_file = get_remote_file( $url.'/timestamp', 2);
+		// Get repository timestamp
+		$remote_file = get_remote_file($url.'/timestamp', 2);
 		$repository_timestamp = empty($remote_file['content']) ? '' : forum_trim($remote_file['content']);
 		unset($remote_file);
 		if (!is_numeric($repository_timestamp))
 			continue;
 
-		if (!isset( $forum_ext_repos[ $url ][ 'timestamp' ] ))
-			$forum_ext_repos[ $url ][ 'timestamp' ] = $repository_timestamp;
+		if (!isset($forum_ext_repos[$url]['timestamp']))
+			$forum_ext_repos[$url]['timestamp'] = $repository_timestamp;
 
-		if ($forum_ext_repos[ $url ][ 'timestamp' ] <= $repository_timestamp)
+		if ($forum_ext_repos[$url]['timestamp'] <= $repository_timestamp)
 		{
 			foreach ($inst_exts as $ext)
 			{
@@ -560,28 +572,29 @@
 				if (empty($version) || !preg_match('~^[0-9a-zA-Z\. +-]+$~u', $version))
 					continue;
 
-				$forum_ext_repos[ $url ][ 'extension_versions' ][ $ext['id'] ] = $version;
+				$forum_ext_repos[$url]['extension_versions'][$ext['id']] = $version;
 
-				//If key with current extension exist in array, compare it with version in rep-ry
-				if (!isset($forum_ext_last_versions[ $ext['id'] ]) || ( version_compare($forum_ext_last_versions[ $ext['id'] ][ 'version' ], $version, '<') ) )
+				// If key with current extension exist in array, compare it with version in repository
+				if (!isset($forum_ext_last_versions[$ext['id']]) || (version_compare($forum_ext_last_versions[$ext['id']]['version'], $version, '<')))
 				{
-					$forum_ext_last_versions[ $ext['id'] ] = array('version' => $version, 'repo_url' => $url);
+					$forum_ext_last_versions[$ext['id']] = array('version' => $version, 'repo_url' => $url);
 
 					$remote_file = get_remote_file($url.'/'.$ext['id'].'/lastchanges', 2);
 					$last_changes = empty($remote_file['content']) ? '' : forum_trim($remote_file['content']);
 					unset($remote_file);
-					if ( !empty($last_changes) )
-						$forum_ext_last_versions[ $ext['id'] ][ 'changes' ] = $last_changes;
+					if (!empty($last_changes))
+						$forum_ext_last_versions[$ext['id']]['changes'] = $last_changes;
 				}
 			}
-			//Write timestamp to cache
-			$forum_ext_repos[ $url ][ 'timestamp' ] = $repository_timestamp;
+
+			// Write timestamp to cache
+			$forum_ext_repos[$url]['timestamp'] = $repository_timestamp;
 		}
 	}
 
 	if (array_keys($forum_ext_last_versions) != array_keys($inst_exts))
 		foreach ($inst_exts as $ext)
-			if ( !in_array($ext['id'], array_keys($forum_ext_last_versions)) )
+			if (!in_array($ext['id'], array_keys($forum_ext_last_versions)))
 				$forum_ext_last_versions[$ext['id']] = array('version' => $ext['version'], 'repo_url' => '', 'changes' => '');
 
 	($hook = get_hook('ch_generate_ext_versions_cache_check_repository')) ? eval($hook) : null;
@@ -589,7 +602,7 @@
 	// Output config as PHP code
 	if (!write_cache_file(FORUM_CACHE_DIR.'cache_ext_version_notifications.php', '<?php'."\n\n".'if (!defined(\'FORUM_EXT_VERSIONS_LOADED\')) define(\'FORUM_EXT_VERSIONS_LOADED\', 1);'."\n\n".'$forum_ext_repos = '.var_export($forum_ext_repos, true).';'."\n\n".' $forum_ext_last_versions = '.var_export($forum_ext_last_versions, true).";\n\n".'$forum_ext_versions_update_cache = '.time().";\n\n".'?>'))
 	{
-		error('Unable to write configuration cache file to cache directory.<br/>Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
+		error('Unable to write configuration cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
 	}
 }
 
diff -urN punbb-1.4.1/include/common_admin.php punbb-1.4.2/include/common_admin.php
--- punbb-1.4.1/include/common_admin.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/common_admin.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads common functions used in the administration panel.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
diff -urN punbb-1.4.1/include/common.php punbb-1.4.2/include/common.php
--- punbb-1.4.1/include/common.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/common.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads common data and performs various functions necessary for the site to work properly.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -66,7 +66,7 @@
 if (file_exists(FORUM_ROOT.'lang/'.$forum_user['language'].'/common.php'))
 	include FORUM_ROOT.'lang/'.$forum_user['language'].'/common.php';
 else
-	error('There is no valid language pack \''.forum_htmlencode($forum_user['language']).'\' installed.<br/>Please reinstall a language of that name.');
+	error('There is no valid language pack \''.forum_htmlencode($forum_user['language']).'\' installed.<br />Please reinstall a language of that name.');
 
 // Setup the URL rewriting scheme
 if ($forum_config['o_sef'] != 'Default' && file_exists(FORUM_ROOT.'include/url/'.$forum_config['o_sef'].'/forum_urls.php'))
diff -urN punbb-1.4.1/include/dblayer/common_db.php punbb-1.4.2/include/dblayer/common_db.php
--- punbb-1.4.1/include/dblayer/common_db.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/dblayer/common_db.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Loads the proper database layer class.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
diff -urN punbb-1.4.1/include/dblayer/mysqli_innodb.php punbb-1.4.2/include/dblayer/mysqli_innodb.php
--- punbb-1.4.1/include/dblayer/mysqli_innodb.php	2011-10-31 18:51:50.000000000 +0000
+++ punbb-1.4.2/include/dblayer/mysqli_innodb.php	2012-02-09 20:42:20.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * A database layer class that relies on the MySQLi PHP extension.
  *
- * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
+ * @copyright (C) 2008-2012 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -79,14 +79,14 @@
 		if (strlen($sql) > 140000)
 			exit('Insane query. Aborting.');
 
-		if (defined('FORUM_SHOW_QUERIES'))
+		if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 			$q_start = forum_microtime();
 
 		$this->query_result = mysqli_query($this->link_id, $sql);
 
 		if ($this->query_result)
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, sprintf('%.5f', forum_microtime() - $q_start));
 
 			++$this->num_queries;
@@ -95,7 +95,7 @@
 		}
 		else
 		{
-			if (defined('FORUM_SHOW_QUERIES'))
+			if (defined('FORUM_SHOW_QUERIES') || defined('FORUM_DEBUG'))
 				$this->saved_queries[] = array($sql, 0);
 
 			if ($this->in_transaction)
